library IEEE;
use IEEE.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
------------------------------------------------------------------------------

entity top_level is 
generic(n: natural :=8);
  port(
       clk : in std_logic;
       rst : in std_logic;
       en  : in std_logic;
       rs  : in std_logic;
       sel : in std_logic_vector(1 downto 0);
       testin :	in std_logic_vector(n-1 downto 0);
       testout : in std_logic_vector(n-1 downto 0);
       err: out std_logic;
       --dataout : out std_logic_vector(n-1 downto 0);
  
   ----display-----------------------------------
   LE        : out std_logic;
   LRS       : out std_logic;
   LRW       : out std_logic;
   LD        : inout std_logic_vector(n-1 downto 0));
   ----------------------------------------------
            
end top_level;


architecture beh_top_level of top_level is
-------------------------------Komponenty-------------------------------------
component fu1 is 
generic(n: natural :=8);
  port(
       clk     : in std_logic;
       rst     : in std_logic;
       en1      : in std_logic;
       datain1 : in std_logic_vector(n-1 downto 0);
       dataout1 : out std_logic_vector(n-1 downto 0)
      );
end component;

component fu2 is 
generic(n: natural :=8);
  port(
       clk     : in std_logic;
       rst     : in std_logic;
       en2      : in std_logic;
       datain2 : in std_logic_vector(n-1 downto 0);
       dataout2 : out std_logic_vector(n-1 downto 0)
      );
end component;

component fu3 is 
generic(n: natural :=8);
  port(
       clk     : in std_logic;
       rst     : in std_logic;
       en3      : in std_logic;
       datain3 : in std_logic_vector(n-1 downto 0);
       dataout3 : out std_logic_vector(n-1 downto 0)
      );
end component;


component MUX1 is 
generic(n: natural :=8);
  port(
       datain1 : in std_logic_vector(n-1 downto 0);
       testin1 : in std_logic_vector(n-1 downto 0);
       sel1    : in std_logic_vector(1 downto 0);
       muxout1 : out std_logic_vector(n-1 downto 0)
      );
end component;

component MUX2 is 
generic(n: natural :=8);
  port(
       datain2 : in std_logic_vector(n-1 downto 0);
       testin2 : in std_logic_vector(n-1 downto 0);
       sel2    : in std_logic_vector(1 downto 0);
       muxout2 : out std_logic_vector(n-1 downto 0)
      );
end component;

component MUX3 is 
generic(n: natural :=8);
  port(
       datain3 : in std_logic_vector(n-1 downto 0);
       testin3 : in std_logic_vector(n-1 downto 0);
       sel3    : in std_logic_vector(1 downto 0);
       muxout3 : out std_logic_vector(n-1 downto 0)
      );
end component;

component demux1 is 
generic(n: natural :=8);
  port(
       datain1 : in std_logic_vector(n-1 downto 0);
       sel1    : in std_logic_vector(1 downto 0);
       demuxtest1 : out std_logic_vector(n-1 downto 0);
       demuxout1 : out std_logic_vector(n-1 downto 0)
      );
end component;

component demux2 is 
generic(n: natural :=8);
  port(
       datain2 : in std_logic_vector(n-1 downto 0);
       sel2    : in std_logic_vector(1 downto 0);
       demuxtest2 : out std_logic_vector(n-1 downto 0);
       demuxout2 : out std_logic_vector(n-1 downto 0)
      );
end component;

component demux3 is 
generic(n: natural :=8);
  port(
       datain3 : in std_logic_vector(n-1 downto 0);
       sel3    : in std_logic_vector(1 downto 0);
       demuxtest3 : out std_logic_vector(n-1 downto 0);
       demuxout3 : out std_logic_vector(n-1 downto 0)
      );
end component;

component compare is
generic(n: natural :=8);
port(	
        input  : in std_logic_vector(n-1 downto 0);
	intest : in std_logic_vector(n-1 downto 0);
	sel    : in std_logic_vector(1 downto 0);
	output : out std_logic);
end component;

component counter is 
generic(n: natural :=8);
  port(
       clk  : in std_logic;
       rst  : in std_logic;
       en   : in std_logic;
       count: out std_logic_vector(n-1 downto 0)
      );
end component;

component MUX3T is 
generic(n: natural :=8);
  port(
       testin1 : in std_logic_vector(n-1 downto 0);
       testin2 : in std_logic_vector(n-1 downto 0);
       testin3 : in std_logic_vector(n-1 downto 0);
       sel     : in std_logic_vector(1 downto 0);
       muxout  : out std_logic_vector(n-1 downto 0)
      );
end component;


component reg is 
generic(n: natural :=8);
  port(
       clk  : in std_logic;
       rst  : in std_logic;
       en   : in std_logic;
       datain : in std_logic_vector(n-1 downto 0);
       dataout : out std_logic_vector(n-1 downto 0)
      );
end component;


component voter3 is
generic(n: natural :=8);
port(	
        input1 : in std_logic_vector(n-1 downto 0);
	input2 : in std_logic_vector(n-1 downto 0);
	input3 : in std_logic_vector(n-1 downto 0);
	output : out std_logic_vector(n-1 downto 0));
end component;


component lcd_controller is
   port (
      RST      : in std_logic;
      CLK      : in std_logic;

      -- interni rozhrani
      RS       : in std_logic;  -- rozliseni kod data/instrukce
      DATA_IN  : in std_logic_vector (n-1 downto 0);
      WRITE_EN : in std_logic; -- zapis, okamzik planosti RS, DATA_IN (pokud radic prave zpracovava, je zapis zahozen)
      
      --- rozhrani LCD displeje
      DISPLAY_RS   : out   std_logic;
      DISPLAY_DATA : inout std_logic_vector(n-1 downto 0);
      DISPLAY_RW   : out   std_logic;
      DISPLAY_EN   : out   std_logic
);
end component;


---------------------------Propojovaci signaly--------------------------------
signal demuxdatain1,demuxdatain2,demuxdatain3: std_logic_vector(n-1 downto 0);
signal sig_muxout1,sig_muxout2,sig_muxout3: std_logic_vector(n-1 downto 0);
signal sig_voutin1,sig_voutin2,sig_voutin3: std_logic_vector(n-1 downto 0);
signal sig_mux3_1,sig_mux3_2,sig_mux3_3: std_logic_vector(n-1 downto 0);
signal sig_comp1,sig_comp2,sig_count,dataout: std_logic_vector(n-1 downto 0);
signal lcd_en,lcd_rs: std_logic;
-----------------------Propojeni, TMR------------------------------------------
begin  
  f1 : fu1
    port map(
      CLK => CLK,
      RST => RST,
      en1 => en,
      datain1 => sig_muxout1,
      dataout1 => demuxdatain1
     );

    m1 : mux1
    port map(
      datain1 => sig_count,
      testin1 => testin,
      sel1 => sel,
      muxout1 => sig_muxout1
     );

    d1 : demux1
    port map(
      datain1 => demuxdatain1,
      demuxtest1 => sig_mux3_1,
      sel1 => sel,
      demuxout1 => sig_voutin1
     );


  f2 : fu2
    port map(
      CLK => CLK,
      RST => RST,
      en2 => en,
      datain2 => sig_muxout2,
      dataout2 => demuxdatain2
     );

    m2 : mux2
    port map(
      datain2 => sig_count,
      testin2 => testin,
      sel2 => sel,
      muxout2 => sig_muxout2
     );

    d2 : demux2
    port map(
      datain2 => demuxdatain2,
      demuxtest2 => sig_mux3_2,
      sel2 => sel,
      demuxout2 => sig_voutin2
     );

  f3 : fu3
    port map(
      CLK => CLK,
      RST => RST,
      en3 => en,
      datain3 => sig_muxout3,
      dataout3 => demuxdatain3
     );

    m3 : mux3
    port map(
      datain3 => sig_count,
      testin3 => testin,
      sel3 => sel,
      muxout3 => sig_muxout3
     );

    d3 : demux3
    port map(
      datain3 => demuxdatain3,
      demuxtest3 => sig_mux3_3,
      sel3 => sel,
      demuxout3 => sig_voutin3
     );


    mu3 : mux3t
    port map(
      testin1 => sig_mux3_1,
      testin2 => sig_mux3_2,
      testin3 => sig_mux3_3,
      sel => sel,
      muxout => sig_comp2
     );

     r : reg
    port map(
      clk => clk,
      rst => rst,
      en => en,
      datain => testout,
      dataout => sig_comp1
     );

       c : compare
    port map(
      input => sig_comp1,
      intest => sig_comp2,
      sel => sel,
      output => err
     );

     v : voter3
    port map(
      input1 => sig_voutin1,
      input2 => sig_voutin2,
      input3 => sig_voutin3,
      output => dataout
     );

         cnt : counter
    port map(
      clk => clk,
      rst => rst,
      en => en,
      count => sig_count
     );

   -- radic LCD displeje
   lcdctrl: lcd_controller
         port map (
            RST    =>  rst,
            CLK    =>  clk,

            -- ridici signaly
            DATA_IN  => dataout,
            WRITE_EN => en,
            RS => rs,
            --- signaly displeje
            DISPLAY_RS   => LRS,
            DISPLAY_DATA => LD,
            DISPLAY_RW   => LRW,
            DISPLAY_EN   => LE
         );



end beh_top_level;
