// Nazev:   Implementace parseru VHDL
// Soubor:  lex.CPP
// Popis:   implementace lexikalniho analyzatoru
// Datum:   2006-05-10
// Autor:   strakam@fit.vutbr.cz, Martin Straka, DIT 2006
//=============================================================================
#include "parser.h"
#include "lex.h"
#include<windows.h>

list<Tsigpom> SignalListPom;
list<Tsigpom>::iterator it_SignalListPom;
Tsigpom Pomsig;

list<Tgenpom> GenListPom;
list<Tgenpom>::iterator it_GenListPom;
Tgenpom Pomgen;

list<Tinoutport> InoutportList;
list<Tinoutport>::iterator it_InoutportList;
Tinoutport Inoutport;

list<Toutport> OutportList;
list<Toutport>::iterator it_OutportList;
Toutport Outport;

list<Tinport> InportList;
list<Tinport>::iterator it_InportList;
Tinport Inport;

list<Tgeneric> GenericList;
list<Tgeneric>::iterator it_GenericList;
Tgeneric generic;

string modules = "modules";
string item;
string librarys, obsah2, inname;
string entity_name;
string bit_port_pom;
int level;
int count_component;
int count_signal,count_vari;
int strednik, zavorka, carka, knihovna, obsah, typ;
ofstream f, f2;
//------------------------------------------------------------------------------

void add_sig(string name)
{
              Pomsig.name=name;
              SignalListPom.push_back(Pomsig);
}

void add_gen(string name)
{
              Pomgen.name=name;
              GenListPom.push_back(Pomgen);
}


void add_generic(string name,string type,string constant)
{
              generic.name=name;
              generic.type=type;
              generic.constant=constant;
              GenericList.push_back(generic);
}


void add_inport(string name,string type,string bit,string constant)
{
              Inport.name=name;
              Inport.type=type;
              Inport.bit=bit;
              Inport.constant=constant;
              InportList.push_back(Inport);
}


void add_outport(string name,string type,string bit,string constant)
{
              Outport.name=name;
              Outport.type=type;
              Outport.bit=bit;
              Outport.constant=constant;
              OutportList.push_back(Outport);
}

void add_inoutport(string name,string type,string bit,string constant)
{
              Inoutport.name=name;
              Inoutport.type=type;
              Inoutport.bit=bit;
              Inoutport.constant=constant;
              InoutportList.push_back(Inoutport);
}


string PrintComment(string fname, string arch) {
       
   string comment;
   comment = "-- **********************************************************************\n";
   comment += "-- ** This file was generated automatically by FT generator...\n";
   comment += "-- ** Module (part) of FT architecture "+arch+"\n";
   comment += "-- ** VHDL file: "+fname+"\n";
   comment += "-- ** Copyright (C) 2012 Brno University of Technology,\n";
   comment += "-- **                    Faculty of Information Technology\n";
   comment += "-- ** Author(s): Martin Straka <strakam@fit.vutbr.cz>\n";
   comment += "-- **********************************************************************\n\n";
   return comment;
}//PrintComment




//------------------------------------------------------------------------------   
void library(){
    librarys="LIBRARY";
    knihovna=1;
    strednik=1;
    item=lex();
    while (item!="ENTITY" && item!="ARCHITECTURE") { librarys+=item;
    if (item==";") {item=lex(); librarys+="\n"; }
    else item=lex();
    }    
    strednik=0;
    knihovna=0;
}    

//------------------------------------------------------------------------------

void entity(){
  string signal_name,inout,bits,type;
  bool jetam;
  item=lex();
  entity_name=item;
  cout << "Analysis of entity - " << entity_name << " ";
  item=lex();//IS
  item=lex();//PORT GENERIC
  if (item=="END") {
      item=lex();
      cout << item << "konec";
  }//if end
  else { 
          if (item=="GENERIC") {
             item=lex();
             while ((item!="PORT") && (item!="END")){
                   jetam=1;                   
                   while ((item!=":") || (jetam==1)) {
                   if (item==":") jetam=0;
                   else {
                   if ((item!="SIGNAL") && (item!="VARIABLE") && (item!="CONSTANT")) add_gen(item);
                   item=lex();
                   }
                   }//while
           
               typ=1;
               type=lex();
               typ=0; 
                  it_GenListPom=GenListPom.begin();
                  while (it_GenListPom!=GenListPom.end()) {
                  add_generic((*it_GenListPom).name,type,item);
                  it_GenListPom++;}//while
                  GenListPom.clear();   
                  item=lex();    
              }//while
           }//if generic
  
  
           
          if (item=="PORT") {
             item=lex(); //nazev portu
             while (item!="END"){
                   jetam=1;                   
                   while ((item!=":") || (jetam==1)) {
                          if ((item==":")) {jetam=0;}
                          else {
                             if ((item!="SIGNAL") && (item!="VARIABLE") && (item!="CONSTANT")) add_sig(item);
                            item=lex();
                            }//if
                   }//while
               item=lex();//inout  
               if ((item=="IN") || (item=="OUT") || (item=="INOUT")) inout=item; 
               
               typ=1;
               type=lex();
               typ=0;       
              it_SignalListPom=SignalListPom.begin();
              while (it_SignalListPom!=SignalListPom.end()) {
              if (inout=="IN") add_inport((*it_SignalListPom).name,type,bits,item);
              if (inout=="OUT") add_outport((*it_SignalListPom).name,type,bits,item);
              if (inout=="INOUT") add_inoutport((*it_SignalListPom).name,type,bits,item);
              it_SignalListPom++;}//while
              SignalListPom.clear();   
              item=lex();
              }//
              cout << "..."; 
           }//if port
    }//else END
    cout << " Done\n";
    while (item!="ARCHITECTURE") item=lex();
    
} 

//------------------------------------------------------------------------------
  void architecture(short arch){  
  item=lex();
  item=lex();//OF
  item=lex();//jmeno entity
  cout << "Analysis of architecture " << item << " ...";
  item=lex();//IS
  obsah=1;
  item=lex();//IS
  cout << " Done\n";
  string::iterator it;
  string pom;
  pom="";  
   it=obsah2.end();
   while (pom!="DNE") {
     if (*it==' ') pom="";
     else pom+=toupper(*it);
     *it=' ';
     it--;
   }//while
   
   string str = inname;
   CreateDirectory(str.c_str(), NULL);
   str = inname+"\\"+modules;
   CreateDirectory(str.c_str(), NULL);


   
   switch (arch) {
          
     case  _TMR :
           cout << "Generating TMR architecture ...";
           GenerateModul("_prm1","TMR");
           GenerateModul("_prm2","TMR");
           GenerateModul("_prm3","TMR");
           GenerateVoter("_voter","TMR");                      
           GenerateTopTMR("_prm","_voter","_tmr","TMR");
           cout << " Done\n";        
           break;
     case  _3FU_3V :
           cout << "Generating of 3FU-3V architecture ...";           
           GenerateModul("_prm1","3FU-3V");
           GenerateModul("_prm2","3FU-3V");
           GenerateModul("_prm3","3FU-3V");
           GenerateVoterWithErr("_vot_prm1","3FU-3V");
           GenerateVoterWithErr("_vot_prm2","3FU-3V");
           GenerateVoterWithErr("_vot_prm3","3FU-3V");
           GenerateFDEC("_fdec_prm","3FU-3V");                       
           GenerateTopTMR3FU3V("_prm","_vot_prm","_fdec_prm","_3fu_3v","3FU-3V");
           cout << " Done\n"; 
           break;                  
     case  _TMR_2V_CMP :
           cout << "Generating of TMR-2V-CMP architecture ...";           
           GenerateModul("_prm1","TMR-2V-CMP");
           GenerateModul("_prm2","TMR-2V-CMP");
           GenerateModul("_prm3","TMR-2V-CMP");
           GenerateVoterTMR2V("_d_prm","TMR-2V-CMP");                       
           GenerateTopTMR3FU("_prm","_d_prm","_tmr_2v_cmp","TMR-2V-CMP");
           cout << " Done\n"; 
           break;   
     case  _3FU_2MUX_ :
           cout << "Generating of 3FU-2MUX architecture ...";           
           GenerateModul("_prm1","3FU-2MUX");
           GenerateModul("_prm2","3FU-2MUX");
           GenerateModul("_prm3","3FU-2MUX");
           GenerateMPRM3FUA("_d_prm","3FU-2MUX");
           GenerateTopTMR3FU("_prm","_d_prm","_3fu_2mux","3FU-2MUX"); 
           cout << " Done\n"; 
           break;   
     case  _3FU_1MUX :
           cout << "Generating of 3FU-1MUX architecture ...";           
           GenerateModul("_prm1","3FU-1MUX");
           GenerateModul("_prm2","3FU-1MUX");
           GenerateModul("_prm3","3FU-1MUX");
           GenerateMPRM3FUC("_d_prm","3FU-1MUX");
           GenerateTopTMR3FU("_prm","_d_prm","_3fu_1mux","3FU-1MUX"); 
           cout << " Done\n"; 
           break;   
     case  _3FU_2MUX_CMP :
           cout << "Generating of 3FU-2MUX-CMP architecture ...";           
           GenerateModul("_prm1","3FU-2MUX-CMP");
           GenerateModul("_prm2","3FU-2MUX-CMP");
           GenerateModul("_prm3","3FU-2MUX-CMP");
           GenerateMPRM3FUB("_d_prm","3FU-2MUX-CMP");
           GenerateTopTMR3FU("_prm","_d_prm","_3fu_2mux_cmp","3FU-2MUX-CMP"); 
           cout << " Done\n";           
           break;                 
     case  _DUPL_CMP :
           cout << "Generating of DUPLEX-CMP modules ...";
           GenerateModul("_fu1","DUPLEX-CMP");
           GenerateModul("_fu2","DUPLEX-CMP");
           GenerateCmp("_cmp","DUPLEX-CMP");     
           GenerateTopDuplex("_fu","_cmp","_dupl_prm","DUPLEX-CMP");
           cout << " Done\n";
           break;
     case  _FUCH :
           cout << "Generating of FU+CH modules ...";
           GenerateModul("_fu","FU+CH");
           GeneratePRMFUCH("_fu","_ch","","FU+CH");              
           cout << " Done\n";
           break;
     case  _TMR_3CH :
           cout << "Generating of TMR+3CH modules ...";
           GenerateModul("_fu1","TMR+3CH");   
           GeneratePRMFUCH("_fu1","_ch","_prm1","TMR+3CH");
           GenerateModul("_fu2","TMR+3CH");
           GeneratePRMFUCH("_fu2","_ch","_prm2","TMR+3CH");
           GenerateModul("_fu3","TMR+3CH");
           GeneratePRMFUCH("_fu3","_ch","_prm3","TMR+3CH");
           GenerateVoterWithErr("_v_prm","TMR+3CH");
           GenerateTopTMR3("_prm","_v_prm","_tmr3ch","TMR+3CH");     
           cout << " Done\n";
           break;    
     case  _DLP_1CH :
           cout << "Generating of DUPLEX+1CH modules ...";
           GenerateModul("_fu1","DUPLEX+1CH");
           GeneratePRMFUCH("_fu1","_ch","_prm1","DUPLEX+1CH");              
           GenerateModul("_prm2","DUPLEX+1CH"); 
           GenerateMuxWithErrCMP("_m_prm","TDUPLEX+1CH");  
           GenerateTopDPL1("_prm","_m_prm","_prm","_dupl1ch","DUPLEX+1CH");
           cout << " Done\n";
           break;    
     case  _DLP_2CH :
           cout << "Generating of DUPLEX+2CH modules ...";
           GenerateModul("_fu1","DUPLEX+2CH");
           GeneratePRMFUCH("_fu1","_ch","_prm1","DUPLEX+2CH");
           GenerateModul("_fu2","DUPLEX+2CH");    
           GeneratePRMFUCH("_fu2","_ch","_prm2","DUPLEX+2CH");           
           GenerateMuxWithErr("_m_prm","DUPLEX+2CH");
           GenerateTopDPL2("_prm","_m_prm","_prm","_dupl2ch","DUPLEX+2CH");
           cout << " Done\n";
           break;                                                                                                      
     default:
             break;              
   } //switch
}    






void GenerateTopDPL1(string module, string checker, string prm, string top, string arch){
string fname;
  int pom1,pom2;
   fname=inname+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport

   f << "      " << "Err_prm1 : OUT std_logic;\n";
   f << "      " << "Err_prm2 : OUT std_logic;\n";
   f << "      " << "Err_prm_m : OUT std_logic\n";
   
 f << "   );\n";  
 f << "end entity " << entity_name << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << " is" << endl << endl;
  
  for (int n=1; n<3; n++) {
      f << "component " << entity_name+module << n << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

   if (n==1) f << "      " << " ERR" << module << n << " : OUT std_logic;" << endl; 
 
    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
      f << "end component;" << endl << endl;
  }//for 
 

  f << "component " << entity_name+checker << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   
      f << "      " << "Err_prm1_in : IN std_logic;\n";


   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+checker<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+checker << "_out" << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport
   
    f << "      " << "Err" << checker << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << checker << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << checker << "" << " : OUT" << " std_logic" << "\n";
   
  f << "   );\n";  
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------
  for (int n=1; n<3; n++) {
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << n << "_sig" << " : " << (*it_OutportList).type << ";\n";

    it_OutportList++;
   }//while outport
  }

      f << "signal " << "err1_sig" << " : " << "std_logic;\n";

 f << endl;

//======BEGIN=========================
  f << "begin" << endl;

  for (int n=1; n<3; n++) {
      f << entity_name << n << module << " : " << entity_name+module << n << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " => " << (*it_InportList).name << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " => " << (*it_InoutportList).name << ",\n";
      it_InoutportList++;
   }//while inoutport

   if (n==1) f << "      " << "Err_prm" << n << " => err" << n << "_sig,\n";



    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " => " << (*it_OutportList).name+module << n << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
 f << endl;
  }//for 

  f << entity_name << checker << "1" << " : " << entity_name+checker << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   
   
    f << "      " << "ERR_prm1_in => err1_sig,\n";
   
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<3; n++) {
      f << "      " << (*it_OutportList).name+checker<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+checker << "_out" << " => " << (*it_OutportList).name; 
      f << ",\n";
      it_OutportList++;
   }//while outport
   
 
   f << "      " << "Err" << checker << "1" << " => Err_prm1,\n";        
   f << "      " << "Err" << checker << "2" << " => Err_prm2,\n";  

       f << "      " << "Err" << checker << "" << " => Err_prm_m\n";    
    
  f << "   );\n";  
  f << endl;
    
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close(); 

     
}




















void GenerateTopDPL2(string module, string checker, string prm, string top, string arch){
string fname;
  int pom1,pom2;
   fname=inname+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport

   f << "      " << "Err_prm1 : OUT std_logic;\n";
   f << "      " << "Err_prm2 : OUT std_logic;\n";
   f << "      " << "Err_prm_m : OUT std_logic\n";
   
 f << "   );\n";  
 f << "end entity " << entity_name << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << " is" << endl << endl;
  
  for (int n=1; n<3; n++) {
      f << "component " << entity_name+module << n << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

   f << "      " << " ERR" << module << n << " : OUT std_logic;" << endl; 
 
    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
      f << "end component;" << endl << endl;
  }//for 
 

  f << "component " << entity_name+checker << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   
      f << "      " << "Err_prm1_in : IN std_logic;\n";
   f << "      " << "Err_prm2_in : IN std_logic;\n";

   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+checker<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+checker << "_out" << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport
   
    f << "      " << "Err" << checker << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << checker << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << checker << "" << " : OUT" << " std_logic" << "\n";
   
  f << "   );\n";  
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------
  for (int n=1; n<3; n++) {
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << n << "_sig" << " : " << (*it_OutportList).type << ";\n";

    it_OutportList++;
   }//while outport
  }

      f << "signal " << "err1_sig" << " : " << "std_logic;\n";
      f << "signal " << "err2_sig" << " : " << "std_logic;\n";

 f << endl;

//======BEGIN=========================
  f << "begin" << endl;

  for (int n=1; n<3; n++) {
      f << entity_name << n << module << " : " << entity_name+module << n << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " => " << (*it_InportList).name << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " => " << (*it_InoutportList).name << ",\n";
      it_InoutportList++;
   }//while inoutport

   f << "      " << "Err_prm" << n << " => err" << n << "_sig,\n";



    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " => " << (*it_OutportList).name+module << n << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
 f << endl;
  }//for 

  f << entity_name << checker << "1" << " : " << entity_name+checker << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   
   
    f << "      " << "ERR_prm1_in => err1_sig,\n";
       f << "      " << "ERR_prm2_in => err2_sig,\n";
   
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<3; n++) {
      f << "      " << (*it_OutportList).name+checker<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+checker << "_out" << " => " << (*it_OutportList).name; 
      f << ",\n";
      it_OutportList++;
   }//while outport
   
 
   f << "      " << "Err" << checker << "1" << " => Err_prm1,\n";        
   f << "      " << "Err" << checker << "2" << " => Err_prm2,\n";  

       f << "      " << "Err" << checker << "" << " => Err_prm_m\n";    
    
  f << "   );\n";  
  f << endl;
    
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close(); 

     
}















void GenerateMuxWithErrCMP(string module, string arch){

  string fname;      
   int pom1,pom2;        
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   
   f << "      " << "Err_prm1_in : IN std_logic;\n";
      
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<3; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport

    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";      
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << "errcmp_sig" << n << " : " << "std_logic" << ";\n";
      
      n++;
    it_OutportList++;
   }//while outport
     //--------SIGNAL--------------------
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {   
      f << "   signal " << (*it_OutportList).name+module << n << "_sigbouta" << " : " << (*it_OutportList).type << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigboutb" << " : " << (*it_OutportList).type << ";\n";
      n++;
    it_OutportList++;
   }//while outport
    f << "   signal " << "cmp12_sig" << " : " << "std_logic" << ";\n";      
    f << "   signal " << "err1_sig, err2_sig" << " : " << "std_logic" << ";\n\n";
  
  f << "begin" << endl << endl;
      
  f << "  err1_sig <= Err_prm1_in;" << endl << endl; 

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_siga" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "2_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp12_sig" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_siga";
      else f << " or " << (*it_OutportList).name+module << n << "_siga";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

       f << "   err2_sig  <= cmp12_sig and not err1_sig;" << endl << endl;

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigboutb" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_sig = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;  
    
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigbouta" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_sig = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;      
    

   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << "errcmp_sig" << n << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << n << "_sigbouta" << " = " << (*it_OutportList).name+module << n << "_sigboutb";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   Err" << module << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << "errcmp_sig" << n;
      else f << " or " << "errcmp_sig" << n;
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << "_out <= " << (*it_OutportList).name+module << n << "_sigboutb" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;



    f << "   Err" << module << "1" << " <= err1_sig;" << endl;
    f << "   Err" << module << "2" << " <= err2_sig;" << endl << endl;
               
    f << "end " << entity_name+module<< "_BEHAV;"; 
  
   if (f.is_open()) f.close(); 
}


void GenerateMuxWithErr(string module, string arch){
  string fname;      
   int pom1,pom2;        
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   
   f << "      " << "Err_prm1_in : IN std_logic;\n";
   f << "      " << "Err_prm2_in : IN std_logic;\n";

   
   
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<3; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport

    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";      
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << "errcmp_sig" << n << " : " << "std_logic" << ";\n";
      
      n++;
    it_OutportList++;
   }//while outport
     //--------SIGNAL--------------------
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {   
      f << "   signal " << (*it_OutportList).name+module << n << "_sigbouta" << " : " << (*it_OutportList).type << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigboutb" << " : " << (*it_OutportList).type << ";\n";
      n++;
    it_OutportList++;
   }//while outport
      
    f << "   signal " << "err1_sig, err2_sig" << " : " << "std_logic" << ";\n\n";
  
  f << "begin" << endl << endl;
      
  f << "  err1_sig <= Err_prm1_in;" << endl; 
  f << "  err2_sig <= Err_prm2_in;" << endl << endl; 

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigboutb" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_sig = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;  
    
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigbouta" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_sig = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;      
    

   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << "errcmp_sig" << n << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << n << "_sigbouta" << " = " << (*it_OutportList).name+module << n << "_sigboutb";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   Err" << module << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << "errcmp_sig" << n;
      else f << " or " << "errcmp_sig" << n;
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << "_out <= " << (*it_OutportList).name+module << n << "_sigboutb" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;



    f << "   Err" << module << "1" << " <= err1_sig;" << endl;
    f << "   Err" << module << "2" << " <= err2_sig;" << endl << endl;
               
    f << "end " << entity_name+module<< "_BEHAV;"; 
  
   if (f.is_open()) f.close(); 

}


void GeneratePRMFUCH(string module, string checker, string top, string arch){

string fname;
  int pom1,pom2;
   fname=inname+"\\"+modules+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << top << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << top << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << top << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
    
   f << "      " << " ERR" << top << " : OUT std_logic;" << endl; 
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << top << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

   
 f << "   );\n";  
 f << "end entity " << entity_name << top << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << top << " is" << endl << endl;
  
      f << "component " << entity_name+module  << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module  << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

 f << "   );\n";   
      f << "end component;" << endl << endl;

 
  f << "component " << entity_name+checker << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
  
       f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name  << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport
        
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << " : IN" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << ";\n";
      it_OutportList++;
   }//while outport

   f << "      " << " ERR" << " : OUT std_logic" << endl; 
  f << "   );\n";  
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------

   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << "_sig" << " : " << (*it_OutportList).type << ";\n";
    it_OutportList++;
   }//while outport
  

 f << endl;

//======BEGIN=========================
  f << "begin" << endl;

      f << entity_name << module << "x : " << entity_name+module << endl;


   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << " => " << (*it_InportList).name << top << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << " => " << (*it_InoutportList).name << top  << ",\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module  << " => " << (*it_OutportList).name+module  << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
 f << endl;


  f << entity_name << checker << "1" << " : " << entity_name+checker << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port map(" << endl;
   
      //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << " => " << (*it_InportList).name << top  << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " => " << (*it_InoutportList).name << top << ",\n";
      it_InoutportList++;
   }//while inoutport
   
   
   
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name<< " => " << (*it_OutportList).name+module << "_sig" << ",\n";

      it_OutportList++;
   }//while outport
 
    f << "      " << "ERR" << " => " << "ERR"  << top << endl;
    f << "   );\n";  
    f << endl;
    
    //-----OUTPORT----
   
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+top << " <= " << (*it_OutportList).name+module << "_sig" << ";\n";
      it_OutportList++;
   }//while outport
  f << endl;
   
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close(); 
     
}



void GenerateTopTMR3(string module, string prm, string top, string arch){
string fname;
  int pom1,pom2;
   fname=inname+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport

   f << "      " << "Err_prm1 : OUT std_logic;\n";
   f << "      " << "Err_prm2 : OUT std_logic;\n";
   f << "      " << "Err_prm3 : OUT std_logic;\n";
   f << "      " << "Err_prm_v : OUT std_logic\n";
   
 f << "   );\n";  
 f << "end entity " << entity_name << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << " is" << endl << endl;
  
  for (int n=1; n<4; n++) {
      f << "component " << entity_name+module << n << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << ";\n";
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << n << " : OUT" << " std_logic" << "\n";

 f << "   );\n";   
      f << "end component;" << endl << endl;
  }//for 
 

  f << "component " << entity_name+prm << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+prm<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+prm << "_out" << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport
   
    f << "      " << "Err" << prm << "_out" << " : OUT" << " std_logic" << "\n";
   
  f << "   );\n";  
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------
  for (int n=1; n<4; n++) {
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << n << "_sig" << " : " << (*it_OutportList).type << ";\n";
    it_OutportList++;
   }//while outport
  }

 f << endl;

//======BEGIN=========================
  f << "begin" << endl;

  for (int n=1; n<4; n++) {
      f << entity_name << n << module << " : " << entity_name+module << n << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " => " << (*it_InportList).name << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " => " << (*it_InoutportList).name << ",\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " => " << (*it_OutportList).name+module << n << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << ",\n";
      it_OutportList++;
   }//while outport
   
   f << "      " << "Err" << module << n  << " => Err" << module << n << "\n";
   
 f << "   );\n";   
 f << endl;
  }//for 

  f << entity_name << prm << "1" << " : " << entity_name+prm << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+prm<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+prm << "_out" << " => " << (*it_OutportList).name; 
      f << ",\n";
      it_OutportList++;
   }//while outport
   
       f << "      " << "Err" << prm << "_out" << " => Err_prm_v\n";    
    
  f << "   );\n";  
  f << endl;
    
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close();             
}

//------------------------------------------------------------------------------
//------GenerateTopDuplex-------------------------------------------------------
//------GenerateTopDuplex-------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateTopDuplex(string module, string voter, string top, string arch){
string fname;
  int pom1,pom2;
   fname=inname+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
    
   f << "      " << " ERR : OUT std_logic;" << endl; 
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

   
 f << "   );\n";  
 f << "end entity " << entity_name << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << " is" << endl << endl;
  
  for (int n=1; n<3; n++) {
      f << "component " << entity_name+module << n << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

 f << "   );\n";   
      f << "end component;" << endl << endl;
  }//for 
 
  f << "component " << entity_name+voter << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
    f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<3; n++) {
      f << "      " << (*it_OutportList).name+voter<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
  f << "      " << "ERR_cmp" << " : OUT std_logic\n";
   
  f << "   );\n";  
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------
  for (int n=1; n<3; n++) {
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << n << "_sig" << " : " << (*it_OutportList).type << ";\n";
    it_OutportList++;
   }//while outport
  }

 f << endl;

//======BEGIN=========================
  f << "begin" << endl;

  for (int n=1; n<3; n++) {
      f << entity_name << n << module << " : " << entity_name+module << n << endl;


   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " => " << (*it_InportList).name << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " => " << (*it_InoutportList).name << ",\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " => " << (*it_OutportList).name+module << n << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
 f << endl;
  }//for 

  f << entity_name << voter << "1" << " : " << entity_name+voter << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port map(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<3; n++) {
      f << "      " << (*it_OutportList).name+voter<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
    f << "      " << "ERR" << voter << " => " << "ERR" << endl;
    f << "   );\n";  
    f << endl;
    
    //-----OUTPORT----
   
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name << " <= " << (*it_OutportList).name+module << "1_sig" << ";\n";
      it_OutportList++;
   }//while outport
  f << endl;
   
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close();     
}
     
     
     
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

void GenerateCmp(string module, string arch){
string fname;
   int pom1,pom2;
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name+module << " is" << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
    f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<3; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
  f << "      " << "ERR_cmp" << " : OUT std_logic\n";
   
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n";    
    
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl << endl;
  
  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << (*it_OutportList).name+module << n << "_sig" << " : " << "std_logic" << ";\n";
      n++;
    it_OutportList++;
   }//while outport
  
  f << endl << "begin" << endl << endl;

	    //ERR12 <= '0' when CIN1=CIN2 else '1';  
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sig" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "2_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   ERR_cmp" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sig";
      else f << " or " << (*it_OutportList).name+module << n << "_sig";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
               
  f << "end " << entity_name+module<< "_BEHAV;"; 
  
   if (f.is_open()) f.close(); 
     
}



//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateTopTMR(string module, string voter, string top, string arch){
string fname;
  int pom1,pom2;
   fname=inname+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

   
 f << "   );\n";  
 f << "end entity " << entity_name << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << " is" << endl << endl;
  
  for (int n=1; n<4; n++) {
      f << "component " << entity_name+module << n << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

 f << "   );\n";   
      f << "end component;" << endl << endl;
  }//for 
 

  f << "component " << entity_name+voter << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+voter<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+voter << "_out" << " : OUT" << (*it_OutportList).type; 
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
  f << "   );\n";  
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------
  for (int n=1; n<4; n++) {
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << n << "_sig" << " : " << (*it_OutportList).type << ";\n";
    it_OutportList++;
   }//while outport
  }

 f << endl;


//======BEGIN=========================
  f << "begin" << endl;

  for (int n=1; n<4; n++) {
      f << entity_name << n << module << " : " << entity_name+module << n << endl;


   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " => " << (*it_InportList).name << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " => " << (*it_InoutportList).name << ",\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " => " << (*it_OutportList).name+module << n << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
 f << endl;
  }//for 

  f << entity_name << voter << "1" << " : " << entity_name+voter << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+voter<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+voter << "_out" << " => " << (*it_OutportList).name; 
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
  f << "   );\n";  
  f << endl;
    
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close();     
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateTopTMR3FU(string module, string voter, string top, string arch){
string fname;
  int pom1,pom2;
   fname=inname+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport

   f << "      " << "Err_prm1 : OUT std_logic;\n";
   f << "      " << "Err_prm2 : OUT std_logic;\n";
   f << "      " << "Err_prm3 : OUT std_logic;\n";
   f << "      " << "Err_prm_d : OUT std_logic\n";
   
 f << "   );\n";  
 f << "end entity " << entity_name << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << " is" << endl << endl;
  
  for (int n=1; n<4; n++) {
      f << "component " << entity_name+module << n << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

 f << "   );\n";   
      f << "end component;" << endl << endl;
  }//for 
 

  f << "component " << entity_name+voter << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+voter<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+voter << "_out" << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport
   
    f << "      " << "Err" << voter << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << voter << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << voter << "3" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << voter << "" << " : OUT" << " std_logic" << "\n";
   
  f << "   );\n";  
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------
  for (int n=1; n<4; n++) {
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << n << "_sig" << " : " << (*it_OutportList).type << ";\n";
    it_OutportList++;
   }//while outport
  }

 f << endl;

//======BEGIN=========================
  f << "begin" << endl;

  for (int n=1; n<4; n++) {
      f << entity_name << n << module << " : " << entity_name+module << n << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " => " << (*it_InportList).name << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " => " << (*it_InoutportList).name << ",\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " => " << (*it_OutportList).name+module << n << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
 f << endl;
  }//for 

  f << entity_name << voter << "1" << " : " << entity_name+voter << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+voter<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+voter << "_out" << " => " << (*it_OutportList).name; 
      f << ",\n";
      it_OutportList++;
   }//while outport
   
 
   f << "      " << "Err" << voter << "1" << " => Err_prm1,\n";        
   f << "      " << "Err" << voter << "2" << " => Err_prm2,\n";  
    f << "      " << "Err" << voter << "3" << " => Err_prm3,\n";  
       f << "      " << "Err" << voter << "" << " => Err_prm_d\n";    
    
  f << "   );\n";  
  f << endl;
    
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close();     
}



//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateTopTMR3FU3V(string module, string voter, string fdec, string top, string arch){
string fname;
  int pom1,pom2;
   fname=inname+"\\"+inname+top+".vhd";
f.open(fname.c_str());
   if (f==NULL) { 
     cout << "Can't open output file - " << fname << " !";}
  f << PrintComment(fname,arch);
f << librarys;

     //--------ENTITY of Checker--------------------------------------   
f << endl << endl << "entity " << entity_name << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }


   f <<  "   port(" << endl;
   
 int ix;
 for (ix=1; ix<4; ix++) {   
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name << ix << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name << ix << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
 
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name << ix << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport
}

   f << "      " << "Err_prm1 : OUT std_logic;\n";
   f << "      " << "Err_prm2 : OUT std_logic;\n";
   f << "      " << "Err_prm3 : OUT std_logic;\n";
   f << "      " << "Err_v_prm1 : OUT std_logic;\n";
   f << "      " << "Err_v_prm2 : OUT std_logic;\n";
   f << "      " << "Err_v_prm3 : OUT std_logic;\n";
   f << "      " << "Err_prm_d : OUT std_logic\n";
   
 f << "   );\n";  
 f << "end entity " << entity_name << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name<< "_BEHAV" << " of " << entity_name << " is" << endl << endl;
  
  for (int n=1; n<4; n++) {
      f << "component " << entity_name+module << n << " is " << endl;
  
   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }

   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " : IN" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " : INOUT" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " : OUT" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

 f << "   );\n";   
      f << "end component;" << endl << endl;
  }//for 
 
  for (int n=1; n<4; n++) {
  f << "component " << entity_name+voter << n << " is " << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << n << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
     
      for (int xn=1; xn<4; xn++) {
      f << "      " << (*it_OutportList).name+voter<< n << xn << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+voter << n << "_out" << " : OUT" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport
   
    f << "      " << "Err" << voter  << n << "_out" << " : OUT" << " std_logic" << "\n";
   
  f << "   );\n";  
  f << "end component;" << endl << endl;

  }//for  


 f << "component " << entity_name+fdec << " is " << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name+fdec << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+fdec<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << fdec <<  "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << fdec <<  "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << fdec <<  "3" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << fdec <<  "" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";   
  f << "end component;" << endl << endl;
    
//--------SIGNAL--------------------
  for (int n=1; n<4; n++) {
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "signal " << (*it_OutportList).name+module << n << "_sig" << " : " << (*it_OutportList).type << ";\n";
    it_OutportList++;
   }//while outport
  }

 f << endl;



//======BEGIN=========================
  f << "begin" << endl;

  for (int n=1; n<4; n++) {
      f << entity_name << n << module << " : " << entity_name+module << n << endl;


   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }


   f <<  "   port map(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << n << " => " << (*it_InportList).name << n << ",\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << n << " => " << (*it_InoutportList).name << n << ",\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----
   int pom1,pom2;
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << n << " => " << (*it_OutportList).name+module << n << "_sig";
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 f << "   );\n";   
 f << endl;
  }//for 


  f << entity_name << fdec << "1" << " : " << entity_name+fdec << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }



   f <<  "   port map(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+fdec<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
  
   f << "      " << "Err" << fdec << "1 => Err_prm1,\n";
   f << "      " << "Err" << fdec << "2 => Err_prm2,\n";
   f << "      " << "Err" << fdec << "3 => Err_prm3,\n";
   f << "      " << "Err" << fdec << " => Err_prm_d\n";      
   
  f << "   );\n";  
  f << endl;


 for (ix=1; ix<4; ix++) {
  f << entity_name << voter << ix << "1" << " : " << entity_name+voter << ix << endl;

   if (!GenericList.empty()) {                        
   f <<  "   generic map(" << endl;                           
    //-----Generic----
   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " => " << (*it_GenericList).name;
      if (pom1>=pom2) f << ",\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   )\n"; 
   }

   f <<  "   port map(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+voter << ix<< n << "_in" << " => " << (*it_OutportList).name+module << n << "_sig" << ",\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----
   
   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+voter << ix << "_out" << " => " << (*it_OutportList).name << ix <<",\n";
      it_OutportList++;
   }//while outport   
   f << "      " << "Err" << voter << ix << "_out => Err_v_prm" << ix << "\n";        
  f << "   );\n";  
  f << endl;

} //for

                   
  f << "end " << entity_name<< "_BEHAV;";
 
 if (f.is_open()) f.close();     
}


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateVoter(string module, string arch){
   string fname;
   int pom1,pom2;
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport
 
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;
  f << "begin" << endl;
  f << "   process(";
      int xxx;
      xxx=0;
      it_OutportList=OutportList.begin();
      while (it_OutportList!=OutportList.end()) {

      for (int n=1; n<4; n++) {
      if (xxx==1 ) f <<  ",";     
      f << (*it_OutportList).name+module << n << "_in";
      xxx=1; 
      }
      it_OutportList++;
   }//while outport
   
  f << ")" << endl;
  f << "    begin" << endl;
  
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+module << "_out" << " <= ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "2_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "2_in" << " and " << (*it_OutportList).name+module << "3_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "3_in" << ");" << endl;             
      it_OutportList++;
   }//while outport
  f << "   end process;" << endl;
  f << "end " << entity_name+module<< "_BEHAV;";
 
 if (f.is_open()) f.close();     
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateVoterWithErr(string module, string arch){
   string fname;
   int pom1,pom2;
      fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";
      it_OutportList++;
   }//while outport
 f << "      " << "Err" << module << "_out" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;


  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << (*it_OutportList).name+module << n << "_siga" << " : " << (*it_OutportList).type << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigb" << " : " << (*it_OutportList).type << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sig_cmp" << " : " << " std_logic" << ";\n";

      n++;
    it_OutportList++;
   }//while outport

  f << "begin" << endl;
  f << "   process(";
      int xxx;
      xxx=0;
      it_OutportList=OutportList.begin();
      while (it_OutportList!=OutportList.end()) {

      for (int n=1; n<4; n++) {
      if (xxx==1 ) f <<  ",";     
      f << (*it_OutportList).name+module << n << "_in";
      xxx=1; 
      }
      it_OutportList++;
   }//while outport
   
  f << ")" << endl;
  f << "    begin" << endl;
  n=1;
  
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+module << n << "_siga" << " <= ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "2_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "2_in" << " and " << (*it_OutportList).name+module << "3_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "3_in" << ");" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   n=1;
      it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << (*it_OutportList).name+module << n << "_sigb" << " <= ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "2_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "2_in" << " and " << (*it_OutportList).name+module << "3_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "3_in" << ");" << endl;             
      n++;
      it_OutportList++;
   }//while outport
       f << endl; 
       
   f << "   end process;" << endl << endl;  
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sig_cmp" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << n << "_siga" << " = " << (*it_OutportList).name+module << n << "_sigb";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   Err" << module << "_out" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sig_cmp";
      else f << " or " << (*it_OutportList).name+module << n << "_sig_cmp";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
  f << "end " << entity_name+module<< "_BEHAV;";
 
 if (f.is_open()) f.close();     
}


//------------------------------------------------------------------------------
//-------GenerateVoterTMR-------------------------------------------------------
//-------GenerateVoterTMR-------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateVoterTMR(string module, string arch){
   string fname;
   int pom1,pom2;
      fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";
      it_OutportList++;
   }//while outport
 f << "      " << "Err" << module << "_out" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  it_OutportList=OutportList.begin();

  f << "      " << "signal" << " Voter1out_sig, Voter2out_sig : "  << (*it_OutportList).type << ";\n";

  f << "begin" << endl;
  f << "   process(";
      int xxx;
      xxx=0;
      it_OutportList=OutportList.begin();
      while (it_OutportList!=OutportList.end()) {

      for (int n=1; n<4; n++) {
      if (xxx==1 ) f <<  ",";     
      f << (*it_OutportList).name+module << n << "_in";
      xxx=1; 
      }
      it_OutportList++;
   }//while outport
   
  f << ")" << endl;
  f << "    begin" << endl;
  
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << "Voter1out_sig" << " <= ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "2_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "2_in" << " and " << (*it_OutportList).name+module << "3_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "3_in" << ");" << endl;             
      it_OutportList++;
   }//while outport
   
      it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "      " << "Voter2out_sig" << " <= ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "2_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "2_in" << " and " << (*it_OutportList).name+module << "3_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "3_in" << ");" << endl;             
      it_OutportList++;
   }//while outport
   
   f << "      " << "Err" << module << "_out" << " <= '0' when " <<  "Voter1out_sig"  << " = "  << "Voter2out_sig"  << " else '1';"  << "\n";
   
  f << "   end process;" << endl;
  f << "end " << entity_name+module<< "_BEHAV;";
 
 if (f.is_open()) f.close();     
}


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateFDEC(string module, string arch){
   string fname;      
   int pom1,pom2;        
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "3" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << (*it_OutportList).name+module << n << "_siga" << " : " << "std_logic" << ";\n";
   f << "   signal " << (*it_OutportList).name+module << n << "_sigb" << " : " << "std_logic" << ";\n";
      n++;
    it_OutportList++;
   }//while outport
    f << "   signal " << "cmp13_sig, cmp23_sig" << " : " << "std_logic" << ";\n"; 
  f << "   signal " << "err1_sig, err2_sig, err3_sig, errfdec_sig" << " : " << "std_logic" << ";\n\n";
  
  f << "begin" << endl << endl;


	    //ERR12 <= '0' when CIN1=CIN2 else '1';  
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_siga" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp13_sig" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_siga";
      else f << " or " << (*it_OutportList).name+module << n << "_siga";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

  	    //ERR12 <= '0' when CIN1=CIN2 else '1';  
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigb" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "2_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp23_sig" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigb";
      else f << " or " << (*it_OutportList).name+module << n << "_sigb";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
  
  f << "  err3_sig <= cmp13_sig and cmp23_sig;" << endl;    
  f << "  err1_sig <= cmp13_sig and not err3_sig;" << endl; 
  f << "  err2_sig <= cmp23_sig and not err3_sig;" << endl;    
  f << "  errfdec_sig <= err1_sig or err2_sig or err3_sig;" << endl; 
  

    f << "   Err" << module << "1" << " <= err1_sig;" << endl;
    f << "   Err" << module << "2" << " <= err2_sig;" << endl;
    f << "   Err" << module << "3" << " <= err3_sig;" << endl;
    f << "   Err" << module << ""  << " <= errfdec_sig;" << endl;
               
  f << "end " << entity_name+module<< "_BEHAV;"; 
  
   if (f.is_open()) f.close(); 
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateMPRM3FUC(string module, string arch){
   string fname;      
   int pom1,pom2;        
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport

    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";      
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "3" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << (*it_OutportList).name+module << n << "_siga" << " : " << "std_logic" << ";\n";
      n++;
    it_OutportList++;
   }//while outport
   
     n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << (*it_OutportList).name+module << n << "_sigb" << " : " << "std_logic" << ";\n";
      n++;
    it_OutportList++;
   }//while outport
   
   
    f << "   signal " << "cmp13_sig, cmp23_sig" << " : " << "std_logic" << ";\n"; 
  f << "   signal " << "err1_sig, err2_sig, err3_sig, errfdec_sig" << " : " << "std_logic" << ";\n\n";
  
  f << "begin" << endl << endl;
 
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_siga" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp13_sig" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_siga";
      else f << " or " << (*it_OutportList).name+module << n << "_siga";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigb" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "2_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp23_sig" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigb";
      else f << " or " << (*it_OutportList).name+module << n << "_sigb";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
   
  f << "  err3_sig <= cmp13_sig and cmp23_sig;" << endl;    
  f << "  err1_sig <= cmp13_sig and not err3_sig;" << endl; 
  f << "  err2_sig <= cmp23_sig and not err3_sig;" << endl;    
  f << "  errfdec_sig <= err1_sig or err2_sig or err3_sig;" << endl<< endl; 

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << "_out" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_sig = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;  

    f << "   Err" << module << "1" << " <= err1_sig;" << endl;
    f << "   Err" << module << "2" << " <= err2_sig;" << endl;
    f << "   Err" << module << "3" << " <= err3_sig;" << endl;
    f << "   Err" << module << ""  << " <= errfdec_sig;" << endl << endl;
               
    f << "end " << entity_name+module<< "_BEHAV;"; 
  
   if (f.is_open()) f.close(); 
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateMPRM3FUA(string module, string arch){
   string fname;      
   int pom1,pom2;        
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport

    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";      
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "3" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << "errcmp_sig" << n << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_siga" << " : " << "std_logic" << ";\n";
      n++;
    it_OutportList++;
   }//while outport
     //--------SIGNAL--------------------
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << (*it_OutportList).name+module << n << "_sigb" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigbouta" << " : " << (*it_OutportList).type << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigboutb" << " : " << (*it_OutportList).type << ";\n";
      n++;
    it_OutportList++;
   }//while outport
      
    f << "   signal " << "cmp13_sig, cmp23_sig" << " : " << "std_logic" << ";\n"; 
    f << "   signal " << "err1_sig, err2_sig, err3_sig, errfdec_sig" << " : " << "std_logic" << ";\n\n";
  
  f << "begin" << endl << endl;
 
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_siga" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp13_sig" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_siga";
      else f << " or " << (*it_OutportList).name+module << n << "_siga";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigb" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "2_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp23_sig" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigb";
      else f << " or " << (*it_OutportList).name+module << n << "_sigb";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
   
  f << "  err3_sig <= cmp13_sig and cmp23_sig;" << endl;    
  f << "  err1_sig <= cmp13_sig and not err3_sig;" << endl; 
  f << "  err2_sig <= cmp23_sig and not err3_sig;" << endl << endl; 

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigboutb" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_sig = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;  
    
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigbouta" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_sig = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;      
    

   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << "errcmp_sig" << n << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << n << "_sigbouta" << " = " << (*it_OutportList).name+module << n << "_sigboutb";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   Err" << module << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << "errcmp_sig" << n;
      else f << " or " << "errcmp_sig" << n;
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << "_out <= " << (*it_OutportList).name+module << n << "_sigboutb" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;



    f << "   Err" << module << "1" << " <= err1_sig;" << endl;
    f << "   Err" << module << "2" << " <= err2_sig;" << endl;
    f << "   Err" << module << "3" << " <= err3_sig;" << endl << endl;
               
    f << "end " << entity_name+module<< "_BEHAV;"; 
  
   if (f.is_open()) f.close(); 
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateMPRM3FUB(string module, string arch){
   string fname;      
   int pom1,pom2;        
   fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport

    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";      
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "3" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "" << " : OUT" << " std_logic" << "\n";
 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << "errcmp_sig" << n << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_siga" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigb" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigc" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigd" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigbouta" << " : " << (*it_OutportList).type << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigboutb" << " : " << (*it_OutportList).type << ";\n";

      n++;
    it_OutportList++;
   }//while outport
      
    f << "   signal " << "cmp13_siga, cmp23_siga, cmp13_sigb, cmp23_sigb" << " : " << "std_logic" << ";\n"; 
    f << "   signal " << "err1_siga, err2_siga, err3_siga, err1_sigb, err2_sigb, err3_sigb, err_sig_mux" << " : " << "std_logic" << ";\n";
    f << "   signal " << "err_sig_cmp1, err_sig_cmp2, err_sig_cmp3, err_sig_cmp" << " : " << "std_logic" << ";\n\n";
  
  f << "begin" << endl << endl;
 
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_siga" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp13_siga" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_siga";
      else f << " or " << (*it_OutportList).name+module << n << "_siga";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigb" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "2_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp23_siga" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigb";
      else f << " or " << (*it_OutportList).name+module << n << "_sigb";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
   
  f << "  err3_siga <= cmp13_siga and cmp23_siga;" << endl;    
  f << "  err1_siga <= cmp13_siga and not err3_siga;" << endl; 
  f << "  err2_siga <= cmp23_siga and not err3_siga;" << endl << endl; 

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigc" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp13_sigb" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigc";
      else f << " or " << (*it_OutportList).name+module << n << "_sigc";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigd" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "2_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp23_sigb" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigd";
      else f << " or " << (*it_OutportList).name+module << n << "_sigd";
      n++;
      it_OutportList++;
   }//while outport

  f << ";" << endl << endl;

  f << "  err3_sigb <= cmp13_sigb and cmp23_sigb;" << endl;    
  f << "  err1_sigb <= cmp13_sigb and not err3_sigb;" << endl; 
  f << "  err2_sigb <= cmp23_sigb and not err3_sigb;" << endl << endl; 

    
  f << "  err_sig_cmp1 <= err1_siga and err1_sigb;"  << endl;
  f << "  err_sig_cmp2 <= err2_siga and err2_sigb;" << endl;
  f << "  err_sig_cmp3 <= err3_siga and err3_sigb;" << endl;

  f << "  err_sig_cmp <= err_sig_cmp1 or err_sig_cmp2 or err_sig_cmp3;" << endl << endl;
  
     n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigboutb" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_siga = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;  
    
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigbouta" << " <= ";
      f <<  (*it_OutportList).name+module << "1_in" << " when (err1_siga = '0') else " << (*it_OutportList).name+module << "2_in";
      f << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;      
    

   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << "errcmp_sig" << n << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << n << "_sigbouta" << " = " << (*it_OutportList).name+module << n << "_sigboutb";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl << endl;
    
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << "_out <= " << (*it_OutportList).name+module << n << "_sigboutb" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;

   f << "   err_sig_mux <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << "errcmp_sig" << n;
      else f << " or " << "errcmp_sig" << n;
      n++;
      it_OutportList++;
   }//while outport

     f << ";" << endl << endl;
     
    f << "   Err" << module << "1" << " <= err1_siga;" << endl;
    f << "   Err" << module << "2" << " <= err2_siga;" << endl;
    f << "   Err" << module << "3" << " <= err3_siga;" << endl;
    f << "   Err" << module << " <= err_sig_mux or err_sig_cmp;" << endl << endl;
    
    f << "end " << entity_name+module<< "_BEHAV;"; 
  
   if (f.is_open()) f.close(); 
}

//------------------------------------------------------------------------------
//-------GenerateVoterTMR2V-----------------------------------------------------
//-------GenerateVoterTMR2V-----------------------------------------------------
//------------------------------------------------------------------------------
void GenerateVoterTMR2V(string module, string arch){
   string fname;
   int pom1,pom2;
      fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) { 
   cout << "Can't open output file - " << fname << " !";}
   f << PrintComment(fname,arch);
   f << librarys;

     //--------ENTITY of Checker--------------------------------------   
     f << endl << endl << "entity " << entity_name+module << " is" << endl;


   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }
   f <<  "   port(" << endl;
   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
       for (int n=1; n<4; n++) {
      f << "      " << (*it_OutportList).name+module<< n << "_in" << " : IN" << (*it_OutportList).type << ";\n";
      }
      it_OutportList++;
   }//while outport
 
    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << "_out" << " : OUT" << (*it_OutportList).type; 
      f << ";\n";
      it_OutportList++;
   }//while outport

    f << "      " << "Err" << module << "1" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "2" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "3" << " : OUT" << " std_logic" << ";\n";
    f << "      " << "Err" << module << "" << " : OUT" << " std_logic" << "\n";


 f << "   );\n";  
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n"; 
   
   //--------ARCHITECTURE of Checker-------------------------------------- 
  f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl;

  //--------SIGNAL--------------------
   int n;
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   signal " << "errcmp_sig" << n << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_siga" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigb" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigc" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigd" << " : " << "std_logic" << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigbouta" << " : " << (*it_OutportList).type << ";\n";
      f << "   signal " << (*it_OutportList).name+module << n << "_sigboutb" << " : " << (*it_OutportList).type << ";\n";

      n++;
    it_OutportList++;
   }//while outport
      
    f << "   signal " << "cmp13_siga, cmp23_siga, cmp13_sigb, cmp23_sigb" << " : " << "std_logic" << ";\n"; 
    f << "   signal " << "err1_siga, err2_siga, err3_siga, err1_sigb, err2_sigb, err3_sigb, err_sig_mux" << " : " << "std_logic" << ";\n";
    f << "   signal " << "err_sig_cmp1, err_sig_cmp2, err_sig_cmp3, err_sig_cmp" << " : " << "std_logic" << ";\n\n";
  
  f << "begin" << endl << endl;
 
    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_siga" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp13_siga" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_siga";
      else f << " or " << (*it_OutportList).name+module << n << "_siga";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigb" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "2_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp23_siga" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigb";
      else f << " or " << (*it_OutportList).name+module << n << "_sigb";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;
   
  f << "  err3_siga <= cmp13_siga and cmp23_siga;" << endl;    
  f << "  err1_siga <= cmp13_siga and not err3_siga;" << endl; 
  f << "  err2_siga <= cmp23_siga and not err3_siga;" << endl << endl; 

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigc" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "1_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp13_sigb" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigc";
      else f << " or " << (*it_OutportList).name+module << n << "_sigc";
      n++;
      it_OutportList++;
   }//while outport
  
  f << ";" << endl << endl;

    n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << n << "_sigd" << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << "2_in" << " = " << (*it_OutportList).name+module << "3_in";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;
   f << "   cmp23_sigb" << " <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << (*it_OutportList).name+module << n << "_sigd";
      else f << " or " << (*it_OutportList).name+module << n << "_sigd";
      n++;
      it_OutportList++;
   }//while outport

  f << ";" << endl << endl;

  f << "  err3_sigb <= cmp13_sigb and cmp23_sigb;" << endl;    
  f << "  err1_sigb <= cmp13_sigb and not err3_sigb;" << endl; 
  f << "  err2_sigb <= cmp23_sigb and not err3_sigb;" << endl << endl; 

    
  f << "  err_sig_cmp1 <= err1_siga and err1_sigb;"  << endl;
  f << "  err_sig_cmp2 <= err2_siga and err2_sigb;" << endl;
  f << "  err_sig_cmp3 <= err3_siga and err3_sigb;" << endl;

  f << "  err_sig_cmp <= err_sig_cmp1 or err_sig_cmp2 or err_sig_cmp3;" << endl << endl;
  
  n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "  " << (*it_OutportList).name+module << n << "_sigboutb" << " <= ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "2_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "2_in" << " and " << (*it_OutportList).name+module << "3_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "3_in" << ");" << endl;                               
      n++;
      it_OutportList++;
   }//while outport
    f << endl;  
    
   n=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {      
      f << "  " << (*it_OutportList).name+module << n << "_sigbouta" << " <= ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "2_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "2_in" << " and " << (*it_OutportList).name+module << "3_in" << ")";
      f << " or ";
      f << "(" << (*it_OutportList).name+module << "1_in" << " and " << (*it_OutportList).name+module << "3_in" << ");" << endl;             
      n++;              
      it_OutportList++;
   }//while outport
    f << endl;        
    

   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << "errcmp_sig" << n << " <= ";
      f << "'0'" << " when ";
      f <<  (*it_OutportList).name+module << n << "_sigbouta" << " = " << (*it_OutportList).name+module << n << "_sigboutb";
      f << " else " << "'1'" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl << endl;
    
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << "_out <= " << (*it_OutportList).name+module << n << "_sigboutb" << ";" << endl;             
      n++;
      it_OutportList++;
   }//while outport
    f << endl;

   f << "   err_sig_mux <= ";
   
   n=1;      
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      if (n==1) f << "errcmp_sig" << n;
      else f << " or " << "errcmp_sig" << n;
      n++;
      it_OutportList++;
   }//while outport

     f << ";" << endl << endl;
     
    f << "   Err" << module << "1" << " <= err1_siga;" << endl;
    f << "   Err" << module << "2" << " <= err2_siga;" << endl;
    f << "   Err" << module << "3" << " <= err3_siga;" << endl;
    f << "   Err" << module << " <= err_sig_mux or err_sig_cmp;" << endl << endl;
    
    f << "end " << entity_name+module<< "_BEHAV;"; 

 
 if (f.is_open()) f.close();     
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void GenerateModul(string module, string arch){
   int pom1,pom2;
   string fname;
      fname=inname+"\\"+modules+"\\"+inname+module+".vhd";
   f.open(fname.c_str());
   if (f==NULL) cout << "Can't open output file - " << fname << " !";
   f << PrintComment(fname,arch);
   f << librarys;

   //--------ENTITY of Checker--------------------------------------   
   f << endl << endl << "entity " << entity_name+module << " is" << endl;

   if (!GenericList.empty()) { 
                           
   f <<  "   generic(" << endl;                           
    //-----Generic----

   pom1=GenericList.size(); 
   pom2=1;
   it_GenericList=GenericList.begin();
   while (it_GenericList!=GenericList.end()) {
      pom2++;
      f << "      " << (*it_GenericList).name << " : " << (*it_GenericList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_GenericList++;
   }//while outport

   f << "   );\n"; 
   }


   f <<  "   port(" << endl;
   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "      " << (*it_InportList).name+module << " : in" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport
   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "      " << (*it_InoutportList).name+module << " : inout" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport

    //-----OUTPORT----

   pom1=OutportList.size(); 
   pom2=1;
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      pom2++;
      f << "      " << (*it_OutportList).name+module << " : out" << (*it_OutportList).type;
      if (pom1>=pom2) f << ";\n";
      else f << "\n";
      it_OutportList++;
   }//while outport

 f << "   );\n";   
 f << "end entity " << entity_name+module << ";" << endl << endl;       
 f << "\n";       
        
        //--------ARCHITECTURE of Checker-------------------------------------- 
        f << "architecture " << entity_name+module<< "_BEHAV" << " of " << entity_name+module << " is" << endl << endl;

   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "   " << "signal " << (*it_InportList).name << " :" << (*it_InportList).type << ";\n";
      it_InportList++;
   }//while inport

   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << "signal " << (*it_OutportList).name<< " :" << (*it_OutportList).type << ";\n";
      it_OutportList++;
   }//while outport

   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "   " << "signal " << (*it_InoutportList).name << " :" << (*it_InoutportList).type << ";\n";
      it_InoutportList++;
   }//while inoutport
f << obsah2; 


   //-----INPORT----
   it_InportList=InportList.begin();
   while (it_InportList!=InportList.end()) {
      f << "   " << (*it_InportList).name << " <= " << (*it_InportList).name+module << ";\n";
      it_InportList++;
   }//while inport

   //-----OUTPORT----
   it_OutportList=OutportList.begin();
   while (it_OutportList!=OutportList.end()) {
      f << "   " << (*it_OutportList).name+module << " <= " << (*it_OutportList).name << ";\n";
      it_OutportList++;
   }//while outport

   //-----INOUTPORT----
   it_InoutportList=InoutportList.begin();
   while (it_InoutportList!=InoutportList.end()) {
      f << "   " << (*it_InoutportList).name+module << " <= " << (*it_InoutportList).name << ";\n";
      it_InoutportList++;
   }//while inoutport

 f << endl<< "end " << entity_name+module<< "_BEHAV;";
 
 if (f.is_open()) f.close();
}


//===================syntax analize=============================================
void parse(short arch){
        item=lex();
        if (item=="LIBRARY") library();
        if (item=="ENTITY") entity();
        if (item=="ARCHITECTURE") architecture(arch);
}//parse
