// Nazev:   Implementace parseru VHDL
// Soubor:  lex.CPP
// Popis:   implementace rozpoznavaciho analyzatoru
// Datum:   2006-05-10
// Autor:   strakam@fit.vutbr.cz, Martin Straka, DIT 2006
//========================================================================
#ifndef parserH
#define parserH
#include "lex.h"

const short _TMR = 0;
const short _3FU_3V = 1;
const short _TMR_2V_CMP = 2;
const short _3FU_2MUX_ = 3;
const short _3FU_1MUX = 4;
const short _3FU_2MUX_CMP = 5;
const short _DUPL_CMP = 6;

const short _FUCH = 7;
const short _TMR_3CH = 8;
const short _DLP_1CH = 9;
const short _DLP_2CH = 10;

using namespace std;
// -----------------------------------------------------------------------------

// --------SIGNALY NA RADKU----------------------------------------------------
typedef struct{    
    string name;} Tsigpom;
extern list<Tsigpom> SignalListPom;
extern list<Tsigpom>::iterator it_SignalListPom;
extern Tsigpom Pomsig;

// --------GENERIC na Radku----------------------------------------------------
typedef struct{    
    string name;} Tgenpom;
extern list<Tgenpom> GenListPom;
extern list<Tgenpom>::iterator it_GenListPom;
extern Tgenpom Pomgen;

// --------GENERIC PORT----------------------------------------------------
typedef struct{    
            string name;
            string type;
            string constant;
            } Tgeneric;   
extern list<Tgeneric> GenericList;
extern list<Tgeneric>::iterator it_GenericList;
extern Tgeneric generic;
    
 // --------IN PORT----------------------------------------------------
typedef struct{    
             string name;
             string type;
             string bit;
             string constant;
             } Tinport;   
extern list<Tinport> InportList;
extern list<Tinport>::iterator it_InportList;
extern Tinport Inport;
    
 // --------OUT PORT----------------------------------------------------
typedef struct{    
                    string name;
                    string type;
                    string bit;
                    string constant;
                    } Toutport;   
extern list<Toutport> OutportList;
extern list<Toutport>::iterator it_OutportList;
extern Toutport Outport;

// --------INOUT PORT----------------------------------------------------
typedef struct{    
                     string name;
                     string type;
                     string bit;
                     string constant;
                     } Tinoutport;   
extern list<Tinoutport> InoutportList;
extern list<Tinoutport>::iterator it_InoutportList;
extern Tinoutport Inoutport;



// -----------------------------------------------------------------------------
void parse(short arch);
void entity();
void architecture();
void library();
void GenerateModul(string module, string arch);
void GenerateVoter(string module, string arch);
void GenerateVoterTMR(string module, string arch);
void GenerateVoterTMR2V(string module, string arch);
void GenerateVoterWithErr(string module, string arch);
void GenerateTopTMR(string module, string voter, string top, string arch);
void GenerateTopTMR3FU(string module, string voter, string top, string arch);
void GenerateTopTMR3FU3V(string module, string voter, string fdec, string top, string arch);
void GenerateTopDuplex(string module, string voter, string top, string arch);
void GenerateCmp(string module, string arch);
void GenerateFDEC(string module, string arch);
void GenerateMPRM3FUC(string module, string arch);
void GenerateMPRM3FUA(string module, string arch);
void GenerateMPRM3FUB(string module, string arch);
void GenerateFTCH(string module, string chcker, string arch);
void GeneratePRMFUCH(string module, string checker, string top, string arch);
void GenerateTopTMR3(string module, string prm, string top, string arch);
void GenerateTopDPL1(string module, string checker, string prm, string top, string arch);
void GenerateTopDPL2(string module, string checker, string prm, string top, string arch);
void GenerateMuxWithErrCMP(string module, string arch);
void GenerateMuxWithErr(string module, string arch);
 
#endif
